doctype html
html
    head
        meta(charset='UTF-8')
        title bayou map
        link(rel='stylesheet', href='/style.css')
        link(rel='stylesheet', href='http://cdn.leafletjs.com/leaflet-0.7.3/leaflet.css')
        script(src='https://cdn.jsdelivr.net/npm/luxon@1.25.0/build/global/luxon.min.js')
        script(src='https://cdn.jsdelivr.net/npm/chart.js@2.9.3')
        //script(src='https://cdn.jsdelivr.net/npm/luxon@1.22.1')
        script(src='https://cdn.jsdelivr.net/npm/chartjs-adapter-luxon@0.2.1')
        script(src='https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js')
        script(src='http://cdn.leafletjs.com/leaflet-0.7.3/leaflet.js')
        script(src='/js/qrcode.min.js')
        script(src='/js/belfast.js')
        
    body        
        

        <a href="/">Back to home</a>

        <hr>

        //li.boxsmaller <b>Feed Name:</b> "#{feed_name}"
        li.boxsmaller <b>Feed Public Key:</b> #{feed_pubkey}
        li.boxsmaller <b>Feed Home Page:</b> <a href="/data/#{feed_pubkey}">http://#{base_url}/data/#{feed_pubkey}</a>
        li.boxsmaller <b>Download All Feed Data</b>: <a href="/data/#{feed_pubkey}/csv/">CSV</a> | <a href="/data/#{feed_pubkey}/json/">JSON</a>
        li.boxsmaller <b>Download Latest Datapoint Only</b>: <a href="/data/#{feed_pubkey}/latest/">JSON</a>

        p.boxsmaller <b>QR Code</b> with link to this feed (download: <a href="#" download="qrcode.png" id="downloadlink">qrcode_feed_#{feed_pubkey}.png</a>):
        canvas(id='qrcode')

        <div id="mapid" style="width: 800px; height: 400px;"></div>

        script.
            QRCode.toCanvas(document.getElementById('qrcode'), 'http://#{base_url}/data/#{feed_pubkey}', function (error) {
            if (error) console.error(error)
            console.log('success!');
            })

        script.
            var start_lat=44.42849861396812;
            var start_lon=-69.00385950557286;
            var ave_lat = 0;
            var ave_lon = 0;
            var ave_count = 0;
            var mymap = L.map('mapid').setView([start_lat, start_lon], 13);

            L.tileLayer('https://api.mapbox.com/styles/v1/{id}/tiles/{z}/{x}/{y}?access_token=pk.eyJ1IjoibWFwYm94IiwiYSI6ImNpejY4NXVycTA2emYycXBndHRqcmZ3N3gifQ.rJcFIG214AriISLbB6B5aw', {
                maxZoom: 18,
                attribution: 'Map data &copy; <a href="https://www.openstreetmap.org/copyright">OpenStreetMap</a> contributors, ' +
                    'Imagery © <a href="https://www.mapbox.com/">Mapbox</a>',
                id: 'mapbox/streets-v11',
                tileSize: 512,
                zoomOffset: -1
            }).addTo(mymap);
            fetch(`/data/#{feed_pubkey}/json/`)
            .then(response => response.json())
            .then(bdata => {
                var data = bdata.data;
                var coords_vs_time = [];
                for(var i = 0; i < data.length; i++) {
                var timeutc = data[i].timestamp;
                var parameters=data[i].parameters;
                if ((parameters.gps_lat != null) && (parameters.gps_lon != null)) {
                ave_lat=ave_lat+parameters.gps_lat;
                ave_lon=ave_lon+parameters.gps_lon;
                ave_count=ave_count+1;
                var this_gps = [parameters.gps_lat,parameters.gps_lon];
                var this_rssi = parameters.rssi;
                var localtime = luxon.DateTime.fromISO(timeutc).toLocal().toString();
                if (this_rssi == null) this_rssi = 0;
                var this_color = 'red';
                if (this_rssi >= -55) this_color = 'lightgreen';
                if (this_rssi < -65) this_color = 'green';
                if (this_rssi < -70) this_color = 'lightyellow';
                if (this_rssi < -80) this_color = 'yellow';
                if (this_rssi < -85) this_color = 'lightgred';
                if (this_rssi < -90) this_color = 'red';

                coords_vs_time.push({"t":localtime,"coords":this_gps,"rssi":this_rssi, "color":this_color});
                }
                //console.log(luxon.DateTime.fromISO(bdata[i].created));
                }
                console.log(coords_vs_time);
                ave_lat=ave_lat/ave_count;
                ave_lon=ave_lon/ave_count;
                console.log("start",start_lat,start_lon);
                console.log("ave",ave_lat,ave_lon);
                mymap.setView([ave_lat, ave_lon], 17); 
                for (var j = 0; j < coords_vs_time.length; j++) {
                    L.circle(coords_vs_time[j].coords, 1, {
                        color: coords_vs_time[j].color,
                        fillColor: coords_vs_time[j].color,
                        fillOpacity: 0.8
                    }).addTo(mymap).bindPopup(coords_vs_time[j].rssi.toString());
                }

                polygonList=[];
                for (var k = 0; k < coords_vs_time.length; k++) {
                   polygonList.push(coords_vs_time[k].coords);
                }
                console.log(polygonList);

                L.polyline(polygonList).setStyle({weight: 2}).addTo(mymap);

            });

            //- L.marker([51.5, -0.09]).addTo(mymap)
            //-     //.bindPopup("<b>Hello world!</b><br />I am a popup.").openPopup();

            //- L.circle([51.508, -0.11], 500, {
            //-     color: 'red',
            //-     fillColor: '#f03',
            //-     fillOpacity: 0.5
            //- }).addTo(mymap).bindPopup("I am a circle.");

            //- L.polygon([
            //-     [51.509, -0.08],
            //-     [51.503, -0.06],
            //-     [51.51, -0.047]
            //- ]).addTo(mymap).bindPopup("I am a polygon.");


            //- var popup = L.popup();

            //- function onMapClick(e) {
            //-     popup
            //-         .setLatLng(e.latlng)
            //-         .setContent("You clicked the map at " + e.latlng.toString())
            //-         .openOn(mymap);
            //- }

            //- mymap.on('click', onMapClick);
